
function getXMLHttpRequest()
{
	var xmlhttp = null;
	var isIE = (navigator.appName == 'Microsoft Internet Explorer');
	if (isIE && location.protocol == 'file:')
	{
		// Starting in IE7, there's a window.XMLHttpRequest, but it can't be used on local files
		try { xmlhttp = new ActiveXObject('Microsoft.XMLHTTP'); 
		} catch (ex) { xmlhttp = new ActiveXObject('Msxml2.XMLHTTP'); }
	}
	else
	{
		if (window.XMLHttpRequest)
			xmlhttp = new XMLHttpRequest();  // For most browsers
		else if (window.ActiveXObject)
		{
			// For IE6
			try { xmlhttp = new ActiveXObject('Microsoft.XMLHTTP'); 
			} catch (ex) { xmlhttp = new ActiveXObject('Msxml2.XMLHTTP'); }
		}
	}
	return xmlhttp;
}

// Works on ie9 and browsers with typed array support (there are
// some browsers that support typed arrays but don't support 
// binary downloads with xmlhttp, we ignore those)
function loadBinary(url, donecallback, failcallback)
{
	var hasTypedArrays = false;
	try {
		new ArrayBuffer(2);
		hasTypedArrays = true;
	} catch (e) {
		hasTypedArrays = false;
	}
	var xmlhttp = getXMLHttpRequest();
	xmlhttp.open("GET", url, true);
	if (hasTypedArrays)
		xmlhttp.responseType = 'arraybuffer';
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200 || (xmlhttp.status == 0 && (hasTypedArrays ? xmlhttp.response : xmlhttp.responseText))) {
				var data;
				if (hasTypedArrays)
				{
					data = new Uint8Array(xmlhttp.response);
				}
				else
				{
					data = new VBArray(xmlhttp.responseBody).toArray();
				}
				xmlhttp.onreadystatechange = function() {};
				xmlhttp = null;  // to clean out activex circular references

				donecallback(data);
			} else {
				// error
				failcallback();
			}
		}
	};
	try { xmlhttp.send(null); } catch (e) { failcallback(); }
}

function loadXML(url, xmlcallback, failcallback)
{
	// TODO: Should fall back to loading in an iframe
	// if using < ie9 without a DOMParser in order to
	// automatically get nice XML DOM API
	//
	var xmlhttp = getXMLHttpRequest();
	xmlhttp.open("GET", url, true);
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200 || (xmlhttp.status == 0 && xmlhttp.responseXML)) {
				var xml;
				if (window.DOMParser)
				{
					var parser = new DOMParser();
					xml = parser.parseFromString(xmlhttp.responseText, "text/xml");
				}
				else 
				{
//					xml = new ActiveXObject("Microsoft.XMLDOM");
//					xml.async = 'false';
//					xml.loadXML(xmlhttp.responseText); 
					xml = xmlhttp.responseXML;
					if (!xml.documentElement && xmlhttp.responseStream) {
						// IE goes wonky when working with XML files stored locally,
						// so you need this hack to force it to parse the XML
						xml.load(xmlhttp.responseStream);
					}
				}				
				
				xmlhttp.onreadystatechange = function() {};
				xmlhttp = null;  // to clean out activex circular references

				xmlcallback(xml);
			} else {
				// error
				failcallback();
			}
		}
	};
	try { xmlhttp.send(null); } catch (e) { failcallback(); }
}

function loadHTML(url, htmlcallback, failcallback)
{
	var xmlhttp = getXMLHttpRequest();
	xmlhttp.open("GET", url, true);
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200 || (xmlhttp.status == 0 && xmlhttp.responseText)) {
				var html = document.createElementNS('http://www.w3.org/1999/xhtml', 'div');
				html.innerHTML = xmlhttp.responseText;
				
				xmlhttp.onreadystatechange = function() {};
				xmlhttp = null;  // to clean out activex circular references

				htmlcallback(html);
			} else {
				// error
				failcallback();
			}
		}
	};
	try { xmlhttp.send(null); } catch (e) { failcallback(); }
}

